#include "clickModule.h"

//-------------------------------------------------
clickModule::clickModule(){
	
}

//-------------------------------------------------	
void clickModule::setup(){
	bgColor.set(0,0,0);
	arrow.loadImage("images/arrow.png");
	maxClickNum 	= 10;
	clicks 			= new ofVec3f[maxClickNum];
	bDone 			= false;
	reset();
}

//-------------------------------------------------
void clickModule::reset(){
	nClicks 			= 0;
	bDone 				= false;
	lastTimePressed 	= 0;
	pos.set(0,240,0);
	clicks[nClicks].set(pos);
	
	// this is a hack to translate to the center of this object...
	addPoint(ofVec3f(640/2, 480/2,0));
	
	nClicks++;
}


//-------------------------------------------------
void clickModule::update(){
	
	bool bAreWePressed = ofGetMousePressed();
	
	if (bAreWePressed == true && bPressed == false){
		
		// just happened!
		
		if (nClicks < maxClickNum){
			clicks[nClicks].set(ofGetMouseX(), ofGetMouseY(), 0);
			addPoint(ofVec3f(clicks[nClicks].x, 480-clicks[nClicks].y, 0));
			float clickDelay = ofGetElapsedTimef() - lastTimePressed;
			if (clickDelay < 0.25){
				bDone = true;
			}
			lastTimePressed = ofGetElapsedTimef();
			nClicks++;
		} else {
			bDone = true;
		}
	}
	
	bPressed = ofGetMousePressed();
	
}

//-------------------------------------------------
void clickModule::draw(){
	
	ofSetColor(0xffffff);
	
	if (nClicks > 1){
		glBegin(GL_LINE_STRIP);
		for (int i = 0; i < nClicks; i++){
			glVertex2f(clicks[i].x, clicks[i].y);
		}
		glEnd();
	} else {
		ofLine(clicks[0].x, clicks[0].y, ofGetMouseX(), ofGetMouseY());
	}
	
	// draw the arrows
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_COLOR, GL_ONE);
		ofSetColor(0xffffff);
		for (int i = 1; i < nClicks; i++){
			arrow.draw(clicks[i].x, clicks[i].y);
			
			clicks[i].x += ofRandomf(); 	// funny
			clicks[i].y += ofRandomf();
		}
		
		if (!bDone){
			arrow.draw(ofGetMouseX(), ofGetMouseY());
		}
	glDisable(GL_BLEND);
}

//-------------------------------------------------
bool clickModule::bAmIdone(){
	return bDone;
}

//-------------------------------------------------
ofVec3f clickModule::getStartPosition(){
	return ofVec3f(0,240,0);
}

//-------------------------------------------------
float clickModule::getStartAngle(){
	return atan2(ofGetMouseY()-240, ofGetMouseX());;
}
		
		

